#!/usr/bin/perl -w

# LSB Test Execution Framework
# Configuration Save Module (tests_conf_save.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':flock';
use Fcntl ':seek';
use Cwd 'cwd';

autoflush_on();

my $conf_page = "tests_conf.pl";
if ($_GET{"goto"}) {
	$conf_page = $_GET{"goto"};
	$conf_page =~ s/%23/#/;
	$_POST{"form_action"} = "";
}
my $session_profile = ($_COOKIE{"session_id"} ? "~session.".$SERVER_PARAM{"PEER_IP"}.".".$_COOKIE{"session_id"} : "");

my $error;

if (!-d $SERVER_PARAM{"APP_DATA"}."/profiles") {
	system("mkdir -p ".$SERVER_PARAM{"APP_DATA"}."/profiles");
	if (!-d $SERVER_PARAM{"APP_DATA"}."/profiles") {
		$error = "";
	}
}

if (!defined($error)) {
	if ($_POST{"form_action"}) {
		if ($_POST{"form_action"} eq "run_tests") {
			if ($session_profile eq "") {
				$error = "Cannot retrieve session ID! Please, allow cookies in your browser.";
			}
		}
		else {
			$error = "Unknown script action specified!";
		}
	}
	elsif (!$_GET{"goto"}) {
		$error = "Script action not specified!";
	}
}

if (!defined($error)) {
	if ($session_profile ne "") {
		my $full_save_name = $SERVER_PARAM{"APP_DATA"}."/profiles/$session_profile";
		if (open(FILE, "> $full_save_name")) {
			my $architecture = ($_POST{"architecture"} or guess_platform(`uname -m`));
			my $lsb_version  = ($_POST{"lsb_version"} or "3.2");
			my $lsb_profile  = ($_POST{"lsb_profile"} or "core,c++,desktop");
			print FILE "APPLICATION:     ".$_POST{"application"}."\n" if ($_POST{"application"});
			if ($_POST{"paths"}) {
				$_POST{"paths"} =~ s/\r\n/\n/g;
				my @paths_lines = split(/\n/, $_POST{"paths"});
				foreach (@paths_lines) {
					print FILE "PATH:            $_\n" if ($_);
				}
			}
			if ($_POST{"packages"}) {
				$_POST{"packages"} =~ s/\r\n/\n/g;
				my @packages_lines = split(/\n/, $_POST{"packages"});
				foreach (@packages_lines) {
					print FILE "PACKAGE:         $_\n" if ($_);
				}
			}
			print FILE "ARCHITECTURE:    $architecture\n";
			print FILE "LSB_VERSION:     $lsb_version\n";
			print FILE "LSB_PROFILE:     $lsb_profile\n";

			if ($_POST{"comments"}) {
				$_POST{"comments"} =~ s/\r\n/\n/g;
				$_POST{"comments"} =~ s/&/&amp;/g;
				$_POST{"comments"} =~ s/</&lt;/g;
				$_POST{"comments"} =~ s/>/&gt;/g;
				my @comments_lines = split(/\n/, $_POST{"comments"});
				foreach (@comments_lines) {
					print FILE "COMMENTS: $_\n";
				}
			}

			close(FILE);

			if ($_POST{"form_action"} eq "run_tests") {
				if (!$_POST{"application"}) {
					$error = "Application name is not specified.";
				}
				else {
					print "HTTP/1.0 200 OK\n";
					print "Content-type: text/html\n\n";
					print_header("Test Execution", "conf");
					
					# Show timer with waiting message
					print <<DATA;
<div id="progress_info">
<font color="green"><b>Please, wait while the test is running...</b></font><br />
Time elapsed: <span id="timer" style="font-family: monospace; color: blue;">00:00</span></p>
</div>

<script language="javascript" type="text/javascript">
// <![CDATA[
var elapsed_time = 0;
var finished = 0;
function update_timer() {
	++elapsed_time;
	var elem = document.getElementById("timer");
	if (elem && !finished) {
		var m = Math.floor(elapsed_time / 60);
		var s = elapsed_time - m * 60;
		var tmp = "";
		tmp += (m < 10) ? "0" + m : m;
		tmp += ":";
		tmp += (s < 10) ? "0" + s : s;
		elem.innerHTML = tmp;
		setTimeout("update_timer()", 1000);
	}
}

setTimeout("update_timer()", 1000);
// ]]>
</script>
DATA
					print_footer(1);

					my $result_dir;
					my $full_save_name_esc = $full_save_name;
					$full_save_name_esc =~ s/ /\\ /g;
					my $results_path_esc = $CONFIG{"RESULTS_DIR"};
					$results_path_esc =~ s/ /\\ /g;
					my $tests_path_esc = $CONFIG{"TESTS_DIR"};
					$tests_path_esc =~ s/ /\\ /g;
					my $utils_path_esc = $CONFIG{"UTILS_DIR"};
					$utils_path_esc =~ s/ /\\ /g;
					my @test_output = `$utils_path_esc/run_tests.pl --profile=$full_save_name_esc --results-dir=$results_path_esc --tests-dir=$tests_path_esc`;
					my $res = $?;
					foreach (@test_output) {
						$_ =~ s/[\r\n]//g;
						if (m/^ERROR: (.*)$/i) {
							$error .= ($error ? "" : "<br />").$1;
						}
						elsif (m/^RESULT: (.*)$/i) {
							$result_dir = $1;
						}
					}

					if (!defined($error) and $res != 0) {
					    if ($res & 127) {
							$error = "Error executing run_tests.pl (terminated with signal ".($res & 127).(($res & 128) ? ", with coredump" : "").")!";
					    }
					    else {
							$error = "Unknown error: run_tests.pl exited with value ".($res >> 8)."!";
					    }
					}
					if (defined($error)) {
						escape($error);
						print <<DATA;
<script language="javascript" type="text/javascript">
// <![CDATA[
finished = 1;
document.cookie="last_error_text=$error; path=/";
location.replace("$conf_page");
// ]]>
</script>
DATA
					}
					else {
						print <<DATA;
<script language="javascript" type="text/javascript">
// <![CDATA[
finished = 1;
location.replace("tests_results.pl?details=$result_dir");
// ]]>
</script>
DATA
					}
					print "</body>\n</html>\n";
					exit;
				}
			}
		}
		else {
			$error = "Cannot open file $session_profile for writing!<br />$!";
		}
	}
}

print "HTTP/1.0 302 Moved\n";
if (defined($error)) {
	print "Set-Cookie: last_error_text=".escape($error)."; path=/;\n";
}
print "Location: $conf_page\n\n";
